// MCIPlayerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MCIPlayer.h"
#include "MCIPlayerDlg.h"
#include "MyHyperLink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CMyHyperLink	m_hyperlink;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
    m_hyperlink.SetLinkUrl("http://activex.moonvalley.com/");
    m_hyperlink.ActiveToolTip(1);
    m_hyperlink.SetTootTipText("Visit the Moon Valley ActiveX page.");
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_LINK, m_hyperlink);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMCIPlayerDlg dialog

CMCIPlayerDlg::CMCIPlayerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMCIPlayerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMCIPlayerDlg)
	m_file = _T("");
	m_numberOfTimes = 0;
	m_loop = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMCIPlayerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMCIPlayerDlg)
	DDX_Control(pDX, IDC_MVSBUTTON, m_MVSButton);
	DDX_Text(pDX, IDC_FILE, m_file);
	DDX_Text(pDX, IDC_NUMBER_OF_TIMES, m_numberOfTimes);
	DDX_Control(pDX, IDC_MCIACTIVEXCONTROLCTRL1, m_MCIControl);
	DDX_Text(pDX, IDC_LOOP, m_loop);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMCIPlayerDlg, CDialog)
	//{{AFX_MSG_MAP(CMCIPlayerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OPEN, OnOpen)
	ON_BN_CLICKED(IDC_PLAY, OnPlay)
	ON_BN_CLICKED(IDC_ABOUT_BOX, OnAboutBox)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_PLAY_TIMES, OnPlayTimes)
	ON_BN_CLICKED(IDC_LOOP_TOGGLE, OnLoopToggle)
	ON_BN_CLICKED(IDC_MVSBUTTON, OnMvsbutton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMCIPlayerDlg message handlers

BOOL CMCIPlayerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
    m_MVSButton.LoadBitmap(IDB_BITMAP1);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMCIPlayerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMCIPlayerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMCIPlayerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// This method is called when the user clicks the Open button.
void CMCIPlayerDlg::OnOpen() 
{
	// create an open dialog
	CFileDialog obDlg(true, ".gif", NULL, OFN_EXPLORER | OFN_HIDEREADONLY, "MIDI and WAV Files (*.mid; *.wav)|*.mid;*.wav|All Files (*.*)|*.*||", this);

    if (obDlg.DoModal() == IDOK)
	{
		m_MCIControl.SetFile(obDlg.GetPathName()); // set the file name
		m_file = m_MCIControl.GetFile(); // set the file name text
		
		// set the loop text to either "true" or "false"
		if (m_MCIControl.GetLoop() == 1)
		{
			m_loop.Format("true");
		}
		else
		{
			m_loop.Format("false");
		}
		
		UpdateData(FALSE);
	}	
}

// This method is called when the user clicks the Play button
void CMCIPlayerDlg::OnPlay() 
{
	m_MCIControl.Play(); // call the play method
	
	// set the loop text to either "true" or "false"
	if (m_MCIControl.GetLoop() == 1)
	{
		m_loop.Format("true");
	}
	else
	{
		m_loop.Format("false");
	}

	UpdateData(FALSE);
}

// This method is called when the user clicks the About Box button
void CMCIPlayerDlg::OnAboutBox() 
{
	m_MCIControl.AboutBox(); // call the about box method	
}

// This method is called when the user clicks the Stop button
void CMCIPlayerDlg::OnStop() 
{
	m_MCIControl.Stop(); // call the Stop method	
}

// This method is called when the user clicks the PlayTimes button
void CMCIPlayerDlg::OnPlayTimes() 
{
	UpdateData();

	m_MCIControl.PlayTimes(m_numberOfTimes); // call the PlayTimes method
	
	// set the loop text to either "true" or "false"
	if (m_MCIControl.GetLoop() == 1)
	{
		m_loop.Format("true");
	}
	else
	{
		m_loop.Format("false");
	}

	UpdateData(FALSE);
}

// This method is called when the user clicks the Looping button
void CMCIPlayerDlg::OnLoopToggle() 
{
	// do the value toggle
	if (m_MCIControl.GetLoop() != 1)
	{
		m_MCIControl.SetLoop(true);
	}
	else
	{
		m_MCIControl.SetLoop(false);
	}

	// set the loop text to either "true" or "false"
	if (m_MCIControl.GetLoop() == 1)
	{
		m_loop.Format("true");
	}
	else
	{
		m_loop.Format("false");
	}

	UpdateData(FALSE);
}

void CMCIPlayerDlg::OnMvsbutton() 
{
    // Executes an open command to the Moon Valley website.  The system's default
    // viewer for webpages will be initialized to view the page.
    ShellExecute(NULL, "open", "http://www.moonvalley.com/", "", NULL, SW_SHOWNORMAL);	
}
